stages:
  - validate
  - generate
  - release
  - deploy

variables:  
  PIP_CACHE_DIR: "$CI_PROJECT_DIR/.cache/pip"

workflow:
  rules:
    # Trigger pipeline only on merge requests to main or direct commits to main
    - if: $CI_PIPELINE_SOURCE == "merge_request_event" && $CI_MERGE_REQUEST_TARGET_BRANCH_NAME == "main"
    - if: $CI_COMMIT_BRANCH == "main"

# Validate commit messages
validate-commit-messages:
  stage: validate
  image: ghcr.io/cocogitto/cog:latest
  script:
    - cog check
  only:
    - merge_requests
    - main

# Generate HTML pages using MkDocs
generate-pages:
  stage: generate
  image: python:3.9  
  before_script:    
    - apt-get update && apt-get install -y git curl jq  # Install required tools
    - pip install -r requirements.txt  # Install Python dependencies
  script:
    - PUML_URL=$PUML_URL mkdocs build --strict -d public  # Build static site into 'public' directory
  artifacts:
    expose_as: "pages"
    paths:
      - public  # Save the generated pages as an artifact
  retry: 2  # Retry job up to 2 times on failure
  only:
    - merge_requests
    - main

# Generate changelog and release using semantic-release
semantic-release:
  stage: release
  image: node:20
  before_script:
    - npm ci
  script:
    - GL_TOKEN=${TOKEN} npx semantic-release
  rules:
    - if: '$CI_PROJECT_PATH == "bmi/eudi-wallet/eidas-2.0-architekturkonzept" && $CI_COMMIT_BRANCH == "main"'

# deploy job to deploy the generated pages
deploy:
  stage: deploy
  pages: true  
  dependencies:
    - generate-pages  # Use artifacts from generate-pages  
  script:
    - echo "deploy pages"
  artifacts:
    paths:
      - public  
  rules:
    - if: '$CI_PROJECT_PATH == "bmi/eudi-wallet/eidas-2.0-architekturkonzept" && $CI_COMMIT_BRANCH == "main"'
  retry: 2